#include "../include/main.h"
#include "../include/command.h"
#include "../include/status.h"
#include "../include/string.h"
#include "unistd.h"

int main(int argc, char** argv)
{
	//Disk Usage Threshold with a default of 75
	int threshold{75}; // -t

	int c;
    while( ( c = getopt (argc, argv, "t:") ) != -1 )
    {
        switch(c)
        {
            case 't':
            	if (optarg) threshold = std::atoi(optarg);
            	break;
        }
    }

	checkSystemd();
    checkDisk(threshold);
    checkDmesg();
}
