#include "../include/string.h"

int findFirstDelim(std::string input, char delim)
{
    std::vector<int> foundDelim;
    for (unsigned int i{0}; i < input.size(); i++)
    {
        if (input[i] == delim) {
            return i;
        }
    }
    return 0;
}

std::vector<int> findDelim(std::string input, char delim)
{
    std::vector<int> foundDelim;
    for (unsigned int i{0}; i < input.size(); i++)
    {
        if (input[i] == delim) {
            foundDelim.push_back(i);
        }
    }
    return foundDelim;
}

std::string stringRange(std::string string, int start, int end)
{
    std::string temp = "";
    if ((unsigned)end > string.size())
    {
        end = string.size();
    }
    for (int i{start}; i <= end; i++)
    {
        temp += string[i];
    }
    return temp;
}

bool findString(std::string string, std::string substring)
{
	unsigned int substringBase{0};
	for (unsigned int i{0}; i < string.size(); i++)
	{
		if (string[i] == substring[0])
		{
			for (unsigned int x{0}; x <= substring.size(); x++)
			{
				if (string[i+x] == substring[x])
				{
					// Check if
					substringBase++;
					if (x+1 == substring.size() && substringBase == substring.size())
					{
						return true;
					}
				}
			}
		}
	}
	return false;
}

void deallocsString(sString* n) {
    sString* temp;
    temp = n;
    while (temp != NULL)
    {
        delete(temp);
        temp = temp->next;
    }
    n = NULL;
}

void split(std::string input, sString* n, char delim)
{
  // Create a temp variable to hold the current linked-list
  sString* temp = n;
  // Holds where the last space encountered was
  int lastSpace = 0;

  // Iterate over the string
  for (unsigned int i{0}; i < input.size(); i++)
  {
    //Check against preset delimters
    if (input[i] == delim )
    {
      // Addd the string since lastSpace to the current empty linked list
      for (unsigned int x = lastSpace; x < i; x++)
      {
        temp->String += input[x];
      }
      // Increment to the next linked-list
      temp->next = new sString;
      temp = temp->next;
      // Skip over the previous list
      lastSpace = i+1;
    }
  }
  // Last character wont have a delimiter after it so add it on manually
  for (unsigned int i = lastSpace; i < input.size(); i++)
  {
    temp->String += input[i];
  }
  // Encure the last linked item always returns NULL to avoid failing checks later on
  temp->next = NULL;
}

void split(std::string input, sString* n)
{
  // Create a temp variable to hold the current linked-list
  sString* temp = n;
  // Holds where the last space encountered was
  int lastSpace = 0;

  // Iterate over the string
  for (unsigned int i{0}; i < input.size(); i++)
  {
    //Check against preset delimters
    if (input[i] == ' ' || input[i] == '\n' || input[i] == '\0' )
    {
      // Addd the string since lastSpace to the current empty linked list
      for (unsigned int x = lastSpace; x < i; x++)
      {
        temp->String += input[x];
      }
      // Increment to the next linked-list
      temp->next = new sString;
      temp = temp->next;
      // Skip over the previous list
      lastSpace = i+1;
    }
  }
  // Last character wont have a delimiter after it so add it on manually
  for (unsigned int i = lastSpace; i < input.size(); i++)
  {
    temp->String += input[i];
  }

  // Encure the last linked item always returns NULL to avoid failing checks later on
  temp->next = NULL;
}

std::vector<std::string> splitString(std::string input, char delim)
{
  //Init some things
  sString* n;
  n = new sString;
  std::vector<std::string> vectorString;

  // Split the string and store the output in a temp linked list
  split(input, n, delim);

  // Temp pointer to hold linked list
  sString* temp;
  temp = n;

  // Iterate over the linked list until we reach the end
  while (temp != NULL)
  {
    if (temp->String.empty() == false)
    {
      vectorString.push_back(temp->String);
    }
    temp = temp->next;
  }

  deallocsString(n);

  return vectorString;
}

std::vector<std::string> splitString(std::string input)
{
  sString* n;
  n = new sString;
  std::vector<std::string> vectorString;

  split(input, n);

  sString* temp;
  temp = n;
  while (temp != NULL)
  {
    if (temp->String.empty() == false)
    {
      vectorString.push_back(temp->String);
    }
    temp = temp->next;
  }

  deallocsString(n);

  return vectorString;
}
